--Database:		OpenEdge
--Source Database:  	basemodel
--Date:             	18/5/2005
----------------------------------------------
-- Drop tables
----------------------------------------------
DROP TABLE PUB.t_attribute;
DROP TABLE PUB.t_attributeconstraints;
DROP TABLE PUB.t_attributetag;
DROP TABLE PUB.t_authors;
DROP TABLE PUB.t_cardinality;
DROP TABLE PUB.t_category;
DROP TABLE PUB.t_clients;
DROP TABLE PUB.t_complexitytypes;
DROP TABLE PUB.t_connector;
DROP TABLE PUB.t_connectorconstraint;
DROP TABLE PUB.t_connectortag;
DROP TABLE PUB.t_connectortypes;
DROP TABLE PUB.t_constants;
DROP TABLE PUB.t_constrainttypes;
DROP TABLE PUB.t_datatypes;
DROP TABLE PUB.t_diagram;
DROP TABLE PUB.t_diagramlinks;
DROP TABLE PUB.t_diagramobjects;
DROP TABLE PUB.t_diagramtypes;
DROP TABLE PUB.t_document;
DROP TABLE PUB.t_ecf;
DROP TABLE PUB.t_efforttypes;
DROP TABLE PUB.t_files;
DROP TABLE PUB.t_genopt;
DROP TABLE PUB.t_glossary;
DROP TABLE PUB.t_html;
DROP TABLE PUB.t_image;
DROP TABLE PUB.t_implement;
DROP TABLE PUB.t_issues;
DROP TABLE PUB.t_lists;
DROP TABLE PUB.t_mainttypes;
DROP TABLE PUB.t_method;
DROP TABLE PUB.t_metrictypes;
DROP TABLE PUB.t_object;
DROP TABLE PUB.t_objectconstraint;
DROP TABLE PUB.t_objecteffort;
DROP TABLE PUB.t_objectfiles;
DROP TABLE PUB.t_objectmetrics;
DROP TABLE PUB.t_objectproblems;
DROP TABLE PUB.t_objectproperties;
DROP TABLE PUB.t_objectrequires;
DROP TABLE PUB.t_objectresource;
DROP TABLE PUB.t_objectrisks;
DROP TABLE PUB.t_objectscenarios;
DROP TABLE PUB.t_objecttests;
DROP TABLE PUB.t_objecttrx;
DROP TABLE PUB.t_objecttypes;
DROP TABLE PUB.t_ocf;
DROP TABLE PUB.t_operation;
DROP TABLE PUB.t_operationparams;
DROP TABLE PUB.t_operationposts;
DROP TABLE PUB.t_operationpres;
DROP TABLE PUB.t_operationtag;
DROP TABLE PUB.t_package;
DROP TABLE PUB.t_palette;
DROP TABLE PUB.t_paletteitem;
DROP TABLE PUB.t_phase;
DROP TABLE PUB.t_primitives;
DROP TABLE PUB.t_problemtypes;
DROP TABLE PUB.t_projectroles;
DROP TABLE PUB.t_propertytypes;
DROP TABLE PUB.t_requiretypes;
DROP TABLE PUB.t_resources;
DROP TABLE PUB.t_risktypes;
DROP TABLE PUB.t_roleconstraint;
DROP TABLE PUB.t_rtf;
DROP TABLE PUB.t_rtfreport;
DROP TABLE PUB.t_rules;
DROP TABLE PUB.t_scenariotypes;
DROP TABLE PUB.t_script;
DROP TABLE PUB.t_secgroup;
DROP TABLE PUB.t_secgrouppermission;
DROP TABLE PUB.t_seclocks;
DROP TABLE PUB.t_secpermission;
DROP TABLE PUB.t_secpolicies;
DROP TABLE PUB.t_secuser;
DROP TABLE PUB.t_secusergroup;
DROP TABLE PUB.t_secuserpermission;
DROP TABLE PUB.t_snapshot;
DROP TABLE PUB.t_statustypes;
DROP TABLE PUB.t_stereotypes;
DROP TABLE PUB.t_taggedvalue;
DROP TABLE PUB.t_tasks;
DROP TABLE PUB.t_tcf;
DROP TABLE PUB.t_template;
DROP TABLE PUB.t_testclass;
DROP TABLE PUB.t_testplans;
DROP TABLE PUB.t_testtypes;
DROP TABLE PUB.t_trxtypes;
DROP TABLE PUB.t_umlpattern;
DROP TABLE PUB.t_version;
DROP TABLE PUB.t_xref;
DROP TABLE PUB.t_xrefsystem;
DROP TABLE PUB.t_xrefuser;
DROP TABLE PUB.usysOldTables;
DROP TABLE PUB.usysQueries;
DROP TABLE PUB.usysTables;
DROP TABLE PUB.usys_system;
COMMIT;

----------------------------------------------
-- Table structure for t_attribute
----------------------------------------------
CREATE TABLE PUB.t_attribute (
   "Object_ID" INTEGER DEFAULT 0 NOT NULL,
   "Name" VARCHAR(255) NOT NULL,
   Scope VARCHAR(50),
   Stereotype VARCHAR(50),
   Containment VARCHAR(50),
   IsStatic INTEGER DEFAULT 0,
   IsCollection INTEGER DEFAULT 0,
   IsOrdered INTEGER DEFAULT 0,
   AllowDuplicates INTEGER DEFAULT 0,
   LowerBound VARCHAR(50),
   UpperBound VARCHAR(50),
   Container VARCHAR(50),
   Notes VARCHAR(8000),
   Derived VARCHAR(1),
   ID INTEGER PRIMARY KEY,	-- id_seq
   Pos NUMBER(10),
   GenOption VARCHAR(8000),
   "Length" INTEGER,
   "Precision" INTEGER,
   Scale INTEGER,
   Const INTEGER,
   Style VARCHAR(255),
   Classifier VARCHAR(50),
   "Default" VARCHAR(8000),
   "Type" VARCHAR(255),
   ea_guid VARCHAR(50),
   StyleEx VARCHAR(8000)
);

----------------------------------------------
-- Table structure for t_attributeconstraints
----------------------------------------------
CREATE TABLE PUB.t_attributeconstraints (
   "Object_ID" INTEGER DEFAULT 0,
   "Constraint" VARCHAR(255),
   AttName VARCHAR(255),
   "Type" VARCHAR(255),
   Notes VARCHAR(8000),
   ID INTEGER,
   PRIMARY KEY(ID, "Constraint")
);

----------------------------------------------
-- Table structure for t_attributetag
----------------------------------------------
CREATE TABLE PUB.t_attributetag (
   PropertyID INTEGER PRIMARY KEY, 		-- propertyid_seq
   ElementID INTEGER,
   Property VARCHAR(255),
   VALUE VARCHAR(255),
   NOTES VARCHAR(8000),
   ea_guid VARCHAR(40) 
);

----------------------------------------------
-- Table structure for t_authors
----------------------------------------------
CREATE TABLE PUB.t_authors (
   AuthorName VARCHAR(255) PRIMARY KEY,
   Roles VARCHAR(255),
   Notes VARCHAR(8000)
);
   
----------------------------------------------
-- Table structure for t_cardinality
----------------------------------------------
CREATE TABLE PUB.t_cardinality (
   Cardinality VARCHAR(50) PRIMARY KEY
);

----------------------------------------------
-- Table structure for t_category
----------------------------------------------
CREATE TABLE PUB.t_category (
   CategoryID INTEGER PRIMARY KEY, 		-- categoryid_seq
   "Name" VARCHAR(255),
   "Type" VARCHAR(255),
   NOTES VARCHAR(8000)
);

----------------------------------------------
-- Table structure for t_clients
----------------------------------------------
CREATE TABLE PUB.t_clients (
   "Name" VARCHAR(255) PRIMARY KEY,
   Organisation VARCHAR(255),
   Phone1 VARCHAR(50),
   Phone2 VARCHAR(50),
   Mobile VARCHAR(50),
   Fax VARCHAR(50),
   Email VARCHAR(50),
   Roles VARCHAR(255),
   Notes VARCHAR(8000)
);

----------------------------------------------
-- Table structure for t_complexitytypes
----------------------------------------------
CREATE TABLE PUB.t_complexitytypes (
   Complexity VARCHAR(50) PRIMARY KEY ,
   NumericWeight INTEGER DEFAULT 0
);

----------------------------------------------
-- Table structure for t_connector
----------------------------------------------
CREATE TABLE PUB.t_connector (
   Connector_ID INTEGER PRIMARY KEY,		-- connector_id_seq
   "Name" VARCHAR(255),
   Direction VARCHAR(50),
   Notes VARCHAR(20000),
   Connector_Type VARCHAR(50) NOT NULL,
   SubType VARCHAR(50),
   SourceCard VARCHAR(50),
   SourceAccess VARCHAR(50),
   SourceElement VARCHAR(50),
   DestCard VARCHAR(50),
   DestAccess VARCHAR(50),
   DestElement VARCHAR(50),
   SourceRole VARCHAR(255),
   SourceRoleType VARCHAR(50),
   SourceRoleNote VARCHAR(2000),
   SourceContainment VARCHAR(50),
   SourceIsAggregate INTEGER DEFAULT '0',
   SourceIsOrdered INTEGER DEFAULT '0',
   SourceQualifier VARCHAR(50),
   DestRole VARCHAR(255),
   DestRoleType VARCHAR(50),
   DestRoleNote VARCHAR(2000),
   DestContainment VARCHAR(50),
   DestIsAggregate INTEGER DEFAULT '0',
   DestIsOrdered INTEGER DEFAULT '0',
   DestQualifier VARCHAR(50),
   Start_Object_ID INTEGER DEFAULT '0' NOT NULL,
   End_Object_ID INTEGER DEFAULT '0' NOT NULL,
   Top_Start_Label VARCHAR(50),
   Top_Mid_Label VARCHAR(50),
   Top_End_Label VARCHAR(50),
   Btm_Start_Label VARCHAR(50),
   Btm_Mid_Label VARCHAR(50),
   Btm_End_Label VARCHAR(50),
   Start_Edge INTEGER DEFAULT '0',
   End_Edge INTEGER DEFAULT '0',
   PtStartX INTEGER DEFAULT '0',
   PtStartY INTEGER DEFAULT '0',
   PtEndX INTEGER DEFAULT '0',
   PtEndY INTEGER DEFAULT '0',
   SeqNo INTEGER DEFAULT '0',
   HeadStyle INTEGER DEFAULT '0',
   LineStyle INTEGER DEFAULT '0',
   RouteStyle INTEGER DEFAULT '0',
   IsBold INTEGER DEFAULT '0',
   LineColor INTEGER DEFAULT '0',
   Stereotype VARCHAR(50),
   VirtualInheritance CHARACTER(1),
   LinkAccess VARCHAR(50),
   PDATA1 VARCHAR(255),
   PDATA2 VARCHAR(255),
   PDATA3 VARCHAR(255),
   PDATA4 VARCHAR(255),
   PDATA5 VARCHAR(255),
   DiagramID INTEGER DEFAULT '0' NOT NULL,
   ea_guid VARCHAR(40) NOT NULL,
   SourceConstraint VARCHAR(255),
   DestConstraint VARCHAR(255),
   SourceIsNavigable INTEGER,
   DestIsNavigable INTEGER,
   IsRoot INTEGER,
   IsLeaf INTEGER,
   IsSpec INTEGER,
   SourceChangeable VARCHAR(12),
   DestChangeable VARCHAR(12),
   SourceTS VARCHAR(12),
   DestTS VARCHAR(12),
   StateFlags VARCHAR(255),
   ActionFlags VARCHAR(255),
   IsSignal INTEGER,
   IsStimulus INTEGER,
   DispatchAction VARCHAR(255),
   Target2 INTEGER,
   StyleEx VARCHAR(4000),
   SourceStereotype VARCHAR(255),
   DestStereotype VARCHAR(255),
   SourceStyle VARCHAR(2000),
   DestStyle VARCHAR(2000),
   EventFlags VARCHAR(255)
);
      
----------------------------------------------
-- Table structure for t_connectorconstraint
----------------------------------------------
CREATE TABLE PUB.t_connectorconstraint (
   ConnectorID INTEGER DEFAULT '0' NOT NULL,
   "Constraint" VARCHAR(255) NOT NULL,
   ConstraintType VARCHAR(50),
   Notes VARCHAR(8000),
   PRIMARY KEY(ConnectorID, "Constraint")
);

----------------------------------------------
-- Table structure for t_connectortag
----------------------------------------------
CREATE TABLE PUB.t_connectortag (   
   PropertyID INTEGER PRIMARY KEY,		-- propertyid_seq
   ElementID INTEGER,
   Property VARCHAR(255),
   VALUE VARCHAR(255),
   NOTES VARCHAR(8000),
   ea_guid VARCHAR(40)
);

----------------------------------------------
-- Table structure for t_connectortypes
----------------------------------------------
CREATE TABLE PUB.t_connectortypes (
   Connector_Type VARCHAR(50) PRIMARY KEY,
   Description VARCHAR(50)
);
   
----------------------------------------------
-- Table structure for t_constants
----------------------------------------------
CREATE TABLE PUB.t_constants ( 
	ConstantName VARCHAR(50) PRIMARY KEY,
	ConstantValue VARCHAR(255)
);

----------------------------------------------
-- Table structure for t_constrainttypes
----------------------------------------------
CREATE TABLE PUB.t_constrainttypes ( 
	"Constraint" VARCHAR(16) PRIMARY KEY,
	Description VARCHAR(50),
	Notes VARCHAR(8000)
);

----------------------------------------------
-- Table structure for t_datatypes
----------------------------------------------
CREATE TABLE PUB.t_datatypes ( 
	"Type" VARCHAR(50) NOT NULL,
	ProductName VARCHAR(50) NOT NULL,
	DataType VARCHAR(50) ,
	"Size" INTEGER,
	MaxLen INTEGER,
	MaxPrec INTEGER,
	MaxScale INTEGER DEFAULT 0,
	DefaultLen INTEGER,
	DefaultPrec INTEGER,
	DefaultScale INTEGER,
	"User" INTEGER,
	PDATA1 VARCHAR(255),
	PDATA2 VARCHAR(255),
	PDATA3 VARCHAR(255),
	PDATA4 VARCHAR(255),
	HasLength VARCHAR(50),
	GenericType VARCHAR(255),
	DatatypeID INTEGER PRIMARY KEY		-- datatypeid_seq
);

----------------------------------------------
-- Table structure for t_diagram
----------------------------------------------
CREATE TABLE PUB.t_diagram ( 
	Diagram_ID INTEGER PRIMARY KEY,		-- diagram_id_seq
	Package_ID INTEGER DEFAULT 1 NOT NULL,
	ParentID INTEGER DEFAULT 0,
	Diagram_Type VARCHAR(50),
	"Name" VARCHAR(255),
	"Version" VARCHAR(50) DEFAULT '1.0',
	Author VARCHAR(255),
	ShowDetails INTEGER DEFAULT 0,
	Notes VARCHAR(10000),
	Stereotype VARCHAR(50),
	AttPub INTEGER DEFAULT 1,
	AttPri INTEGER DEFAULT 1,
	AttPro INTEGER DEFAULT 1,
	Orientation VARCHAR(1) DEFAULT 'P',
	cx INTEGER DEFAULT 0,
	cy INTEGER DEFAULT 0,
	Scale INTEGER DEFAULT 100,
	CreatedDate TIMESTAMP DEFAULT SYSTIMESTAMP,
	ModifiedDate TIMESTAMP DEFAULT SYSTIMESTAMP,
	HTMLPath VARCHAR(255),
	ShowForeign INTEGER DEFAULT 1,
	ShowBorder INTEGER DEFAULT 1,
	ShowPackageContents INTEGER DEFAULT 1,
	PDATA VARCHAR(255),
	Locked INTEGER,
	ea_guid VARCHAR(40) NOT NULL,
	TPos INTEGER,
	Swimlanes VARCHAR(255),
	StyleEx VARCHAR(10000)
);

----------------------------------------------
-- Table structure for t_diagramlinks
----------------------------------------------   
CREATE TABLE PUB.t_diagramlinks ( 
	DiagramID INTEGER NOT NULL,
	ConnectorID INTEGER NOT NULL,
	Geometry VARCHAR(8000),
	Style VARCHAR(255),
	Hidden INTEGER,
	Path VARCHAR(255),
	Instance_ID INTEGER PRIMARY KEY		-- instance_id_seq
);

----------------------------------------------
-- Table structure for t_diagramobjects
----------------------------------------------
CREATE TABLE PUB.t_diagramobjects ( 
	Diagram_ID INTEGER DEFAULT 0,
	"Object_ID" INTEGER DEFAULT 0,
	RectTop INTEGER DEFAULT 0,
	RectLeft INTEGER DEFAULT 0,
	RectRight INTEGER DEFAULT 0,
	RectBottom INTEGER DEFAULT 0,
	"Sequence" INTEGER DEFAULT 0,
	ObjectStyle VARCHAR(255),
	Instance_ID INTEGER PRIMARY KEY		-- instance_id_seq
);

----------------------------------------------
-- Table structure for t_diagramtypes
----------------------------------------------
CREATE TABLE PUB.t_diagramtypes ( 
	Diagram_Type VARCHAR(50) PRIMARY KEY,
	"Name" VARCHAR(255),
	Package_ID INTEGER DEFAULT 0 NOT NULL
);

----------------------------------------------
-- Table structure for 7
----------------------------------------------
CREATE TABLE PUB.t_document ( 
	DocID VARCHAR(40) PRIMARY KEY,
	DocName VARCHAR(100),
	Notes VARCHAR(255),
	Style VARCHAR(255),
	ElementID VARCHAR(40) NOT NULL,
	ElementType VARCHAR(50) NOT NULL,
	StrContent VARCHAR(8000),
	BinContent BLOB(1000000),
	DocType VARCHAR(100),
	Author VARCHAR(255),
	"Version" VARCHAR(50),
	IsActive INTEGER,
	"Sequence" INTEGER,
	DocDate TIMESTAMP
);

----------------------------------------------
-- Table structure for t_ecf
----------------------------------------------
CREATE TABLE PUB.t_ecf ( 
	ECFID VARCHAR(12) PRIMARY KEY,
	Description VARCHAR(50),
	Weight FLOAT DEFAULT 1 NOT NULL,
	Value FLOAT DEFAULT 0,
	Notes VARCHAR(8000)
);

----------------------------------------------
-- Table structure for t_efforttypes
----------------------------------------------
CREATE TABLE PUB.t_efforttypes ( 
	EffortType VARCHAR(12) PRIMARY KEY,
	Description VARCHAR(255),
	NumericWeight FLOAT DEFAULT 0 NOT NULL,
	Notes VARCHAR(8000)
);

----------------------------------------------
-- Table structure for t_files
----------------------------------------------
CREATE TABLE PUB.t_files ( 
	FileID VARCHAR(50) PRIMARY KEY,
	AppliesTo VARCHAR(100) NOT NULL,
	Category VARCHAR(50) NOT NULL,
	"Name" VARCHAR(150) NOT NULL,
	"File" VARCHAR(255),
	Notes VARCHAR(8000),
	FileDate TIMESTAMP,
	FileSize INTEGER
);

----------------------------------------------
-- Table structure for t_genopt
----------------------------------------------
CREATE TABLE PUB.t_genopt ( 
	AppliesTo VARCHAR(12),
	"Option" VARCHAR(8000)
);

----------------------------------------------
-- Table structure for t_glossary
----------------------------------------------
CREATE TABLE PUB.t_glossary ( 
	Term VARCHAR(255),
	"Type" VARCHAR(255),
	Meaning VARCHAR(8000),
	GlossaryID INTEGER PRIMARY KEY 		-- glossaryid_seq
);

----------------------------------------------
-- Table structure for t_html
----------------------------------------------
CREATE TABLE PUB.t_html ( 
	"Type" VARCHAR(50),
	Template VARCHAR(30000)
);
	
----------------------------------------------
-- Table structure for t_image
----------------------------------------------
CREATE TABLE PUB.t_image ( 
	ImageID INTEGER PRIMARY KEY,		-- imageid_seq
	"Name" VARCHAR(255),
	"Type" VARCHAR(255),
	Image BLOB(1000000) 
);

----------------------------------------------
-- Table structure for t_implement
----------------------------------------------
CREATE TABLE PUB.t_implement ( 
	"Type" VARCHAR(50)
);

----------------------------------------------
-- Table structure for t_issues
----------------------------------------------
CREATE TABLE PUB.t_issues ( 
	Issue VARCHAR(255),
	IssueDate TIMESTAMP,
	Owner VARCHAR(255),
	Status VARCHAR(255),
	Notes VARCHAR(8000),
	Resolver VARCHAR(255),
	DateResolved TIMESTAMP,
	Resolution VARCHAR(8000),
	IssueID INTEGER PRIMARY KEY,		-- issueid_seq
	Category VARCHAR(255),
	Priority VARCHAR(100),
	Severity VARCHAR(50),
	IssueType VARCHAR(100)
);

----------------------------------------------
-- Table structure for t_lists
----------------------------------------------
CREATE TABLE PUB.t_lists ( 
	ListID VARCHAR(50) PRIMARY KEY,
	Category VARCHAR(100) NOT NULL,
	"Name" VARCHAR(150) NOT NULL,
	NVal INTEGER,
	Notes VARCHAR(8000)
);

----------------------------------------------
-- Table structure for t_mainttypes
----------------------------------------------
CREATE TABLE PUB.t_mainttypes ( 
	MaintType VARCHAR(12) PRIMARY KEY,
	Description VARCHAR(50),
	NumericWeight FLOAT DEFAULT 1 NOT NULL,
	Notes VARCHAR(8000)
);

----------------------------------------------
-- Table structure for t_method
----------------------------------------------
CREATE TABLE PUB.t_method ( 
	"Object_ID" INTEGER PRIMARY KEY,
	"Name" VARCHAR(255) NOT NULL,
	Scope VARCHAR(50),
	"Type" VARCHAR(50)
);

----------------------------------------------
-- Table structure for t_metrictypes
----------------------------------------------
CREATE TABLE PUB.t_metrictypes ( 
	Metric VARCHAR(12) NOT NULL PRIMARY KEY,
	Description VARCHAR(50),
	NumericWeight FLOAT DEFAULT 1 NOT NULL,
	Notes VARCHAR(8000)
);

----------------------------------------------
-- Table structure for t_object
----------------------------------------------
CREATE TABLE PUB.t_object ( 
	"Object_ID" INTEGER PRIMARY KEY, 		-- object_id_seq
	Object_Type VARCHAR(255),
	Diagram_ID INTEGER DEFAULT 0,
	"Name" VARCHAR(255),
	Alias VARCHAR(255),
	Author VARCHAR(255),
	"Version" VARCHAR(50) DEFAULT '1.0',
	Note VARCHAR(8000), 
	Package_ID INTEGER DEFAULT 0 NOT NULL,
	Stereotype VARCHAR(255),
	NType INTEGER DEFAULT 0,
	Complexity VARCHAR(50) DEFAULT 2,
	Effort INTEGER DEFAULT 0,
	Style VARCHAR(255),
	Backcolor INTEGER DEFAULT 0,
	BorderStyle INTEGER DEFAULT 0,
	BorderWidth INTEGER DEFAULT 0,
	Fontcolor INTEGER DEFAULT 0,
	Bordercolor INTEGER DEFAULT 0,
	CreatedDate TIMESTAMP DEFAULT SYSTIMESTAMP,
	ModifiedDate TIMESTAMP DEFAULT SYSTIMESTAMP,
	Status VARCHAR(50),
	Abstract VARCHAR(1),
	Tagged INTEGER DEFAULT 0,
	PDATA1 VARCHAR(255),
	PDATA2 VARCHAR(255),
	PDATA3 VARCHAR(255),
	PDATA4 VARCHAR(255),
	PDATA5 VARCHAR(255),
	Concurrency VARCHAR(50),
	Visibility VARCHAR(50),
	Persistence VARCHAR(50),
	Cardinality VARCHAR(50),
	GenType VARCHAR(50),
	GenFile VARCHAR(255),
	Header1 VARCHAR(500),
	Header2 VARCHAR(500),
	Phase VARCHAR(50),
	Scope VARCHAR(25),
	GenOption VARCHAR(2000),
	GenLinks VARCHAR(2000),
	Classifier INTEGER,
	ea_guid VARCHAR(40) NOT NULL,
	ParentID INTEGER,
	RunState VARCHAR(2000),
	Classifier_guid VARCHAR(40),
	TPos INTEGER,
	IsRoot INTEGER,
	IsLeaf INTEGER,
	IsSpec INTEGER,
	IsActive INTEGER,
	StateFlags VARCHAR(255),
	PackageFlags VARCHAR(255),
	Multiplicity VARCHAR(50),
	StyleEx VARCHAR(2000),
	ActionFlags VARCHAR(255),
	EventFlags VARCHAR(255)
);

----------------------------------------------
-- Table structure for t_objectconstraint
----------------------------------------------
CREATE TABLE PUB.t_objectconstraint ( 
	"Object_ID" INTEGER DEFAULT 0 NOT NULL,
	"Constraint" VARCHAR(255) NOT NULL,
	ConstraintType VARCHAR(30) NOT NULL,
	Weight FLOAT DEFAULT 0,
	Notes VARCHAR(30000),
	Status VARCHAR(50),
	PRIMARY KEY ("Object_ID", "Constraint", ConstraintType)
);

----------------------------------------------
-- Table structure for t_objecteffort
----------------------------------------------
CREATE TABLE PUB.t_objecteffort ( 
	"Object_ID" INTEGER DEFAULT 0 NOT NULL,
	Effort VARCHAR(255) NOT NULL,
	EffortType VARCHAR(12),
	EValue FLOAT DEFAULT 0,
	Notes VARCHAR(30000),
	PRIMARY KEY ("Object_ID", Effort)
);

----------------------------------------------
-- Table structure for t_objectfiles
----------------------------------------------
CREATE TABLE PUB.t_objectfiles ( 
	"Object_ID" INTEGER DEFAULT 0 NOT NULL,
	FileName VARCHAR(255) NOT NULL,
	"Type" VARCHAR(50),
	Note VARCHAR(8000),
	FileSize VARCHAR(255),
	FileDate VARCHAR(255),
	PRIMARY KEY ("Object_ID", FileName)
);

----------------------------------------------
-- Table structure for t_objectmetrics
----------------------------------------------
CREATE TABLE PUB.t_objectmetrics ( 
	"Object_ID" INTEGER DEFAULT 0 NOT NULL,
	Metric VARCHAR(255) NOT NULL,
	MetricType VARCHAR(12) NOT NULL,
	EValue FLOAT DEFAULT 1,
	Notes VARCHAR(8000),
	PRIMARY KEY ("Object_ID", Metric)
);

----------------------------------------------
-- Table structure for t_objectproblems
----------------------------------------------
CREATE TABLE PUB.t_objectproblems ( 
	"Object_ID" INTEGER DEFAULT 0 NOT NULL,
	Problem VARCHAR(255) NOT NULL,
	ProblemType VARCHAR(200) NOT NULL,
	DateReported TIMESTAMP,
	Status VARCHAR(50),
	ProblemNotes VARCHAR(8000),
	ReportedBy VARCHAR(255),
	ResolvedBy VARCHAR(255),
	DateResolved TIMESTAMP,
	"Version" VARCHAR(50),
	ResolverNotes VARCHAR(8000),
	Priority VARCHAR(100),
	Severity VARCHAR(50),
	PRIMARY KEY ("Object_ID", Problem, ProblemType)
);

----------------------------------------------
-- Table structure for t_objectproperties
----------------------------------------------
CREATE TABLE PUB.t_objectproperties ( 
	PropertyID INTEGER PRIMARY KEY,		-- propertyid_seq
	"Object_ID" INTEGER DEFAULT 0,
	Property VARCHAR(255),
	Value VARCHAR(255),
	Notes VARCHAR(30000),
	ea_guid VARCHAR(40)
);

----------------------------------------------
-- Table structure for t_objectrequires
----------------------------------------------
CREATE TABLE PUB.t_objectrequires ( 
	ReqID INTEGER PRIMARY KEY,		-- reqid_seq
	"Object_ID" INTEGER DEFAULT 0 NOT NULL,
	Requirement VARCHAR(255),
	ReqType VARCHAR(255),
	Status VARCHAR(50),
	Notes VARCHAR(8000),
	Stability VARCHAR(50),
	Difficulty VARCHAR(50),
	Priority VARCHAR(50),
	LastUpdate VARCHAR(19) DEFAULT SYSDATE
);

----------------------------------------------
-- Table structure for t_objectresource
----------------------------------------------
CREATE TABLE PUB.t_objectresource ( 
	"Object_ID" INTEGER DEFAULT 0 NOT NULL,
	"Resource" VARCHAR(255) NOT NULL,
	Role VARCHAR(200) NOT NULL,
	"Time" FLOAT DEFAULT 0,
	Notes VARCHAR(8000),
	PercentComplete NUMBER(5) DEFAULT 0,
	DateStart TIMESTAMP,
	DateEnd TIMESTAMP,
	History VARCHAR(8000),
	ExpectedHours INTEGER,
	ActualHours INTEGER,
	PRIMARY KEY ("Object_ID", "Resource", Role)
);

----------------------------------------------
-- Table structure for t_objectrisks
----------------------------------------------
CREATE TABLE PUB.t_objectrisks ( 
	"Object_ID" INTEGER DEFAULT 0 NOT NULL,
	Risk VARCHAR(255) NOT NULL,
	RiskType VARCHAR(12),
	EValue FLOAT DEFAULT 0,
	Notes VARCHAR(8000),
	PRIMARY KEY ("Object_ID", Risk) 
);

----------------------------------------------
-- Table structure for t_objectscenarios
----------------------------------------------
CREATE TABLE PUB.t_objectscenarios ( 
	"Object_ID" INTEGER DEFAULT 0 NOT NULL,
	Scenario VARCHAR(255) NOT NULL,
	ScenarioType VARCHAR(12),
	EValue FLOAT DEFAULT 0,
	Notes VARCHAR(20000),
	ea_guid VARCHAR(40) NOT NULL,
	XMLContent VARCHAR(8000),
	PRIMARY KEY ("Object_ID", Scenario) 
);

----------------------------------------------
-- Table structure for t_objecttests
----------------------------------------------
CREATE TABLE PUB.t_objecttests ( 
	"Object_ID" INTEGER DEFAULT 0 NOT NULL,
	Test VARCHAR(255) NOT NULL,
	TestClass INTEGER DEFAULT 0 NOT NULL,
	TestType VARCHAR(50),
	Notes VARCHAR(10000),
	InputData VARCHAR(8000),
	AcceptanceCriteria VARCHAR(8000),
	Status VARCHAR(32),
	DateRun TIMESTAMP DEFAULT SYSTIMESTAMP,
	Results VARCHAR(8000),
	RunBy VARCHAR(255),
	CheckBy VARCHAR(255),
	PRIMARY KEY ("Object_ID", Test, TestClass)
);

----------------------------------------------
-- Table structure for t_objecttrx
----------------------------------------------
CREATE TABLE PUB.t_objecttrx ( 
	"Object_ID" INTEGER DEFAULT 0 NOT NULL,
	TRX VARCHAR(255) NOT NULL,
	TRXType VARCHAR(12) NOT NULL,
	Weight FLOAT DEFAULT 0,
	Notes VARCHAR(30000),
	PRIMARY KEY ("Object_ID", TRX, TRXType) 
);

----------------------------------------------
-- Table structure for t_objecttypes
----------------------------------------------
CREATE TABLE PUB.t_objecttypes ( 
	Object_Type VARCHAR(50) PRIMARY KEY,
	Description VARCHAR(255),
	DesignObject INTEGER,
	ImageID INTEGER DEFAULT 0 NOT NULL
);

----------------------------------------------
-- Table structure for t_ocf
----------------------------------------------
CREATE TABLE PUB.t_ocf ( 
	ObjectType VARCHAR(50),
	ComplexityWeight FLOAT DEFAULT 0 NOT NULL
);

----------------------------------------------
-- Table structure for t_operation
----------------------------------------------
CREATE TABLE PUB.t_operation ( 
	OperationID INTEGER PRIMARY KEY,	-- operationid_seq
	"Object_ID" INTEGER DEFAULT 0 NOT NULL,
	"Name" VARCHAR(255) NOT NULL,
	Scope VARCHAR(50),
	"Type" VARCHAR(255),
	ReturnArray CHARACTER(1),
	Stereotype VARCHAR(50),
	IsStatic CHARACTER(1),
	Concurrency VARCHAR(50),
	Notes VARCHAR(8000),
	Behaviour VARCHAR(8000),
	Abstract CHARACTER(1),
	GenOption VARCHAR(2000),
	Synchronized CHARACTER(1),
	Pos INTEGER,
	Const INTEGER,
	Style VARCHAR(255),
	Pure INTEGER,
	Throws VARCHAR(255),
	Classifier VARCHAR(50),
	Code VARCHAR(20000),
	IsRoot INTEGER,
	IsLeaf INTEGER,
	IsQuery INTEGER,
	StateFlags VARCHAR(255),
	ea_guid VARCHAR(40) NOT NULL,
	StyleEx VARCHAR(2000)
);

----------------------------------------------
-- Table structure for t_operationparams
----------------------------------------------
CREATE TABLE PUB.t_operationparams ( 
	OperationID INTEGER DEFAULT 0 NOT NULL,
	"Name" VARCHAR(255) NOT NULL,
	"Type" VARCHAR(255),
	"Default" VARCHAR(255),
	Notes VARCHAR(20000),
	Pos INTEGER DEFAULT 0 NOT NULL,
	Const INTEGER,
	Style VARCHAR(255),
	Kind VARCHAR(12),
	Classifier VARCHAR(50),
	ea_guid VARCHAR(40) NOT NULL,
	StyleEx VARCHAR(8000),
	PRIMARY KEY (OperationID, "Name") 
);

----------------------------------------------
-- Table structure for t_operationposts
----------------------------------------------
CREATE TABLE PUB.t_operationposts ( 
	OperationID INTEGER DEFAULT 0 NOT NULL,
	PostCondition VARCHAR(255) NOT NULL,
	"Type" VARCHAR(255),
	Notes VARCHAR(30000),
	PRIMARY KEY (OperationID, PostCondition) 
);

----------------------------------------------
-- Table structure for t_operationpres
----------------------------------------------
CREATE TABLE PUB.t_operationpres ( 
	OperationID INTEGER DEFAULT 0 NOT NULL,
	PreCondition VARCHAR(255) NOT NULL,
	"Type" VARCHAR(50),
	Notes VARCHAR(30000),
	PRIMARY KEY (OperationID, PreCondition) 
);

----------------------------------------------
-- Table structure for t_operationtag
----------------------------------------------
CREATE TABLE PUB.t_operationtag ( 
	PropertyID INTEGER PRIMARY KEY,		-- propertyid_seq
	ElementID INTEGER DEFAULT 0 NOT NULL,
	Property VARCHAR(255),
	VALUE VARCHAR(255),
	NOTES VARCHAR(30000),
	ea_guid VARCHAR(40)
);

----------------------------------------------
-- Table structure for t_package
----------------------------------------------
CREATE TABLE PUB.t_package ( 
	Package_ID INTEGER PRIMARY KEY,		-- package_id_seq
	"Name" VARCHAR(255),
	Parent_ID INTEGER DEFAULT 0 NOT NULL,
	CreatedDate TIMESTAMP DEFAULT SYSTIMESTAMP,
	ModifiedDate TIMESTAMP DEFAULT SYSTIMESTAMP,
	Notes VARCHAR(30000),
	ea_guid VARCHAR(40) NOT NULL,
	XMLPath VARCHAR(255),
	IsControlled INTEGER,
	LastLoadDate TIMESTAMP,
	LastSaveDate TIMESTAMP,
	"Version" VARCHAR(50),
	Protected INTEGER,
	PkgOwner VARCHAR(255),
	UMLVersion VARCHAR(50),
	UseDTD INTEGER,
	LogXML INTEGER,
	CodePath VARCHAR(255),
	Namespace VARCHAR(50),
	TPos INTEGER,
	PackageFlags VARCHAR(255),
	BatchSave INTEGER,
	BatchLoad INTEGER
);

----------------------------------------------
-- Table structure for t_palette
----------------------------------------------
CREATE TABLE PUB.t_palette ( 
	PaletteID INTEGER UNIQUE,		-- paletteid_seq
	"Name" VARCHAR(255),
	"Type" VARCHAR(255)
);

----------------------------------------------
-- Table structure for t_paletteitem
----------------------------------------------
CREATE TABLE PUB.t_paletteitem ( 
	PaletteID INTEGER,
	ItemID INTEGER
);

----------------------------------------------
-- Table structure for t_phase
----------------------------------------------
CREATE TABLE PUB.t_phase ( 
	PhaseID VARCHAR(40) PRIMARY KEY,
	PhaseName VARCHAR(100) NOT NULL,
	PhaseNotes VARCHAR(10000),
	PhaseStyle VARCHAR(255),
	StartDate TIMESTAMP,
	EndDate TIMESTAMP,
	PhaseContent VARCHAR(10000)
);

----------------------------------------------
-- Table structure for t_primitives
----------------------------------------------
CREATE TABLE PUB.t_primitives ( 
	Datatype VARCHAR(50) PRIMARY KEY,
	Description VARCHAR(50)
);

----------------------------------------------
-- Table structure for t_problemtypes
----------------------------------------------
CREATE TABLE PUB.t_problemtypes ( 
	ProblemType VARCHAR(12) PRIMARY KEY,
	Description VARCHAR(255),
	NumericWeight FLOAT DEFAULT 1 NOT NULL,
	Notes VARCHAR(30000)
);

----------------------------------------------
-- Table structure for t_projectroles
----------------------------------------------
CREATE TABLE PUB.t_projectroles ( 
	Role VARCHAR(255) PRIMARY KEY,
	Description VARCHAR(255),
	Notes VARCHAR(30000)
);

----------------------------------------------
-- Table structure for t_propertytypes
----------------------------------------------
CREATE TABLE PUB.t_propertytypes ( 
	Property VARCHAR(50) PRIMARY KEY,
	Description VARCHAR(50),
	Notes VARCHAR(30000)
);

----------------------------------------------
-- Table structure for t_requiretypes
----------------------------------------------
CREATE TABLE PUB.t_requiretypes ( 
	Requirement VARCHAR(12) PRIMARY KEY,
	Description VARCHAR(50),
	NumericWeight FLOAT DEFAULT 1 NOT NULL,
	Notes VARCHAR(30000)
);

----------------------------------------------
-- Table structure for t_resources
----------------------------------------------
CREATE TABLE PUB.t_resources ( 
	"Name" VARCHAR(255) PRIMARY KEY,
	Organisation VARCHAR(255),
	Phone1 VARCHAR(50),
	Phone2 VARCHAR(50),
	Mobile VARCHAR(50),
	Fax VARCHAR(50),
	Email VARCHAR(255),
	Roles VARCHAR(255),
	Notes VARCHAR(30000)
);

----------------------------------------------
-- Table structure for t_risktypes
----------------------------------------------
CREATE TABLE PUB.t_risktypes ( 
	Risk VARCHAR(12) PRIMARY KEY,
	Description VARCHAR(50),
	NumericWeight FLOAT DEFAULT 0 NOT NULL,
	Notes VARCHAR(30000)
);

----------------------------------------------
-- Table structure for t_roleconstraint
----------------------------------------------
CREATE TABLE PUB.t_roleconstraint ( 
	ConnectorID INTEGER DEFAULT 0 NOT NULL,
	Constraint_ VARCHAR(255) NOT NULL,
	ConnectorEnd VARCHAR(50) NOT NULL,
	ConstraintType VARCHAR(12) NOT NULL,
	Notes VARCHAR(30000),
	PRIMARY KEY (ConnectorID, Constraint_, ConnectorEnd, ConstraintType) 
);
   
----------------------------------------------
-- Table structure for t_rtf
----------------------------------------------
CREATE TABLE PUB.t_rtf ( 
	"Type" VARCHAR(50),
	Template VARCHAR(30000)
);

----------------------------------------------
-- Table structure for t_rtfreport
----------------------------------------------
CREATE TABLE PUB.t_rtfreport ( 
	TemplateID VARCHAR(200) PRIMARY KEY,
	RootPackage INTEGER DEFAULT 0,
	Filename VARCHAR(255),
	Details INTEGER,
	ProcessChildren INTEGER,
	ShowDiagrams INTEGER,
	Heading VARCHAR(255),
	Requirements INTEGER,
	Associations INTEGER,
	Scenarios INTEGER,
	ChildDiagrams INTEGER,
	Attributes INTEGER,
	Methods INTEGER,
	ImageType INTEGER DEFAULT 0,
	Paging INTEGER,
	Intro VARCHAR(8000),
	Resources INTEGER DEFAULT 1,
	"Constraints" INTEGER DEFAULT 1,
	Tagged INTEGER,
	ShowTag INTEGER,
	ShowAlias INTEGER,
	PDATA1 VARCHAR(255),
	PDATA2 VARCHAR(255),
	PDATA3 VARCHAR(255),
	PDATA4 VARCHAR(8000)
);

----------------------------------------------
-- Table structure for t_rules
----------------------------------------------
CREATE TABLE PUB.t_rules ( 
	RuleID VARCHAR(50) PRIMARY KEY,
	RuleName VARCHAR(255) NOT NULL,
	RuleType VARCHAR(255) NOT NULL,
	RuleActive INTEGER NOT NULL,
	ErrorMsg VARCHAR(255),
	Flags VARCHAR(255),
	RuleOCL VARCHAR(8000),
	RuleXML VARCHAR(8000),
	Notes VARCHAR(8000)
);

----------------------------------------------
-- Table structure for t_scenariotypes
----------------------------------------------
CREATE TABLE PUB.t_scenariotypes ( 
	ScenarioType VARCHAR(12) PRIMARY KEY,
	Description VARCHAR(50),
	NumericWeight FLOAT DEFAULT 1 NOT NULL,
	Notes VARCHAR(8000)
);

----------------------------------------------
-- Table structure for t_script
----------------------------------------------
CREATE TABLE PUB.t_script ( 
	ScriptID INTEGER PRIMARY KEY,		-- scriptid_seq
	ScriptCategory VARCHAR(100),
	ScriptName VARCHAR(150),
	ScriptAuthor VARCHAR(255),
	Notes VARCHAR(8000),
	Script VARCHAR(8000)
);

----------------------------------------------
-- Table structure for t_secgroup
----------------------------------------------
CREATE TABLE PUB.t_secgroup ( 
	GroupID VARCHAR(40) PRIMARY KEY,
	GroupName VARCHAR(32) NOT NULL,
	Description VARCHAR(100)
);

----------------------------------------------
-- Table structure for t_secgrouppermission
----------------------------------------------
CREATE TABLE PUB.t_secgrouppermission ( 
	GroupID VARCHAR(40) NOT NULL,
	PermissionID INTEGER NOT NULL,
	PRIMARY KEY (GroupID, PermissionID) 
);

----------------------------------------------
-- Table structure for t_seclocks
----------------------------------------------
CREATE TABLE PUB.t_seclocks ( 
	UserID VARCHAR(40) NOT NULL,
	GroupID VARCHAR(40),
	EntityType VARCHAR(32) NOT NULL,
	EntityID VARCHAR(40)  PRIMARY KEY,
	"Timestamp" TIMESTAMP NOT NULL,
	LockType VARCHAR(255)
);

----------------------------------------------
-- Table structure for t_secpermission
----------------------------------------------
CREATE TABLE PUB.t_secpermission ( 
	PermissionID INTEGER PRIMARY KEY,
	PermissionName VARCHAR(50) NOT NULL
);

----------------------------------------------
-- Table structure for t_secpolicies
----------------------------------------------
CREATE TABLE PUB.t_secpolicies ( 
	Property VARCHAR(100) PRIMARY KEY,
	Value VARCHAR(255) NOT NULL
);

----------------------------------------------
-- Table structure for t_secuser
----------------------------------------------
CREATE TABLE PUB.t_secuser ( 
	UserID VARCHAR(40) PRIMARY KEY,
	UserLogin VARCHAR(32) NOT NULL,
	FirstName VARCHAR(50) NOT NULL,
	Surname VARCHAR(50) NOT NULL,
	Department VARCHAR(50),
	Password VARCHAR(12)
);

----------------------------------------------
-- Table structure for t_secusergroup
----------------------------------------------
CREATE TABLE PUB.t_secusergroup ( 
	UserID VARCHAR(40) NOT NULL,
	GroupID VARCHAR(40) NOT NULL,
	PRIMARY KEY (UserID, GroupID) 
);

----------------------------------------------
-- Table structure for t_secuserpermission
----------------------------------------------
CREATE TABLE PUB.t_secuserpermission ( 
	UserID VARCHAR(40) NOT NULL,
	PermissionID INTEGER NOT NULL,
	PRIMARY KEY (UserID, PermissionID)
);

----------------------------------------------
-- Table structure for t_snapshot
----------------------------------------------
CREATE TABLE PUB.t_snapshot ( 
	SnapshotID VARCHAR(40) PRIMARY KEY,
	SeriesID VARCHAR(40) NOT NULL,
	Position INTEGER NOT NULL,
	SnapshotName VARCHAR(100) NOT NULL,
	Notes VARCHAR(8000),
	Style VARCHAR(255) NOT NULL,
	ElementID VARCHAR(40),
	ElementType VARCHAR(50) NOT NULL,
	StrContent VARCHAR(8000),
	BinContent1 BLOB(1000000),
	BinContent2 BLOB(1000000)
);

----------------------------------------------
-- Table structure for t_statustypes
----------------------------------------------
CREATE TABLE PUB.t_statustypes ( 
	Status VARCHAR(50) PRIMARY KEY,
	Description VARCHAR(50)
);

----------------------------------------------
-- Table structure for t_stereotypes
----------------------------------------------
CREATE TABLE PUB.t_stereotypes ( 
	Stereotype VARCHAR(255) NOT NULL,
	AppliesTo VARCHAR(200) NOT NULL,
	Description VARCHAR(255),
	MFEnabled INTEGER,
	MFPath VARCHAR(255),
	Metafile BLOB(1000000),
	Style VARCHAR(8000),
	ea_guid VARCHAR(40) NOT NULL,
	VisualType VARCHAR(100),
	PRIMARY KEY (Stereotype, AppliesTo) 
);

----------------------------------------------
-- Table structure for t_taggedvalue
----------------------------------------------
CREATE TABLE PUB.t_taggedvalue ( 
	PropertyID VARCHAR(40) PRIMARY KEY,
	ElementID VARCHAR(40) NOT NULL,
	BaseClass VARCHAR(50) NOT NULL,
	TagValue VARCHAR(8000),
	Notes VARCHAR(8000)
);

----------------------------------------------
-- Table structure for t_tasks
----------------------------------------------
CREATE TABLE PUB.t_tasks ( 
	TaskID INTEGER PRIMARY KEY,		-- taskid_seq
	"Name" VARCHAR(255),
	TaskType VARCHAR(255),
	NOTES VARCHAR(8000),
	Priority VARCHAR(255),
	Status VARCHAR(255),
	Owner VARCHAR(255),
	StartDate TIMESTAMP,
	EndDate TIMESTAMP,
	Phase VARCHAR(50),
	History VARCHAR(8000),
	Percent INTEGER,
	TotalTime INTEGER,
	ActualTime INTEGER,
	AssignedTo VARCHAR(250)
);

----------------------------------------------
-- Table structure for t_tcf
----------------------------------------------
CREATE TABLE PUB.t_tcf ( 
	TCFID VARCHAR(12) NOT NULL ,
	Description VARCHAR(50),
	Weight FLOAT DEFAULT 1 NOT NULL,
	Value FLOAT DEFAULT 0,
	Notes VARCHAR(8000)
);

----------------------------------------------
-- Table structure for t_template
----------------------------------------------
CREATE TABLE PUB.t_template ( 
	TemplateID VARCHAR(40) PRIMARY KEY,
	TemplateType VARCHAR(50) NOT NULL,
	TemplateName VARCHAR(100) NOT NULL,
	Notes VARCHAR(255),
	Style VARCHAR(255),
	Template VARCHAR(8000)
);

----------------------------------------------
-- Table structure for t_testclass
----------------------------------------------
CREATE TABLE PUB.t_testclass ( 
	TestClass VARCHAR(50) PRIMARY KEY,
	Description VARCHAR(50)
);

----------------------------------------------
-- Table structure for t_testplans
----------------------------------------------
CREATE TABLE PUB.t_testplans ( 
	PlanID VARCHAR(50) PRIMARY KEY,
	Category VARCHAR(100) NOT NULL,
	"Name" VARCHAR(100) NOT NULL,
	Author VARCHAR(255),
	Notes VARCHAR(8000),
	TestPlan VARCHAR(8000)
);

----------------------------------------------
-- Table structure for t_testtypes
----------------------------------------------
CREATE TABLE PUB.t_testtypes ( 
	TestType VARCHAR(12) PRIMARY KEY,
	Description VARCHAR(50),
	NumericWeight FLOAT DEFAULT 1 NOT NULL,
	Notes VARCHAR(8000)
);

----------------------------------------------
-- Table structure for t_trxtypes
----------------------------------------------
CREATE TABLE PUB.t_trxtypes ( 
	TRX VARCHAR(255),
	Description VARCHAR(50),
	NumericWeight FLOAT DEFAULT 1,
	Notes VARCHAR(30000),
	Style VARCHAR(1000),
	TRX_ID INTEGER PRIMARY KEY 			-- trx_id_seq
);

----------------------------------------------
-- Table structure for t_umlpattern
----------------------------------------------
CREATE TABLE PUB.t_umlpattern ( 
	PatternID INTEGER PRIMARY KEY,		-- patternid_seq
	PatternCategory VARCHAR(100),
	PatternName VARCHAR(150) NOT NULL,
	Style VARCHAR(250),
	Notes VARCHAR(1000),
	PatternXML VARCHAR(30000),
	"Version" VARCHAR(50)
);

----------------------------------------------
-- Table structure for t_version
----------------------------------------------
CREATE TABLE PUB.t_version ( 
	ElementID VARCHAR(50) NOT NULL,
	VersionID VARCHAR(255) NOT NULL,
	ElementType VARCHAR(100) NOT NULL,
	Flags VARCHAR(255),
	ExternalFile VARCHAR(255),
	Notes VARCHAR(255),
	Owner VARCHAR(255),
	VersionDate TIMESTAMP NOT NULL,
	Branch VARCHAR(255),
	ElementXML VARCHAR(8000),
	PRIMARY KEY (ElementID, VersionID) 
);

----------------------------------------------
-- Table structure for t_xref
----------------------------------------------
CREATE TABLE PUB.t_xref ( 
	XrefID VARCHAR(255) PRIMARY KEY,
	"Name" VARCHAR(255),
	"Type" VARCHAR(255) NOT NULL,
	Visibility VARCHAR(255),
	Namespace VARCHAR(255),
	Requirement VARCHAR(255),
	"Constraint" VARCHAR(255),
	Behavior VARCHAR(255),
	Partition VARCHAR(255),
	Description VARCHAR(8000),
	Client VARCHAR(255),
	Supplier VARCHAR(255),
	"Link" VARCHAR(255)
);

----------------------------------------------
-- Table structure for t_xrefsystem
----------------------------------------------
CREATE TABLE PUB.t_xrefsystem ( 
	XrefID VARCHAR(255) PRIMARY KEY,
	"Name" VARCHAR(255),
	"Type" VARCHAR(255) NOT NULL,
	Visibility VARCHAR(255),
	Namespace VARCHAR(255),
	Requirement VARCHAR(255),
	"Constraint" VARCHAR(255),
	Behavior VARCHAR(255),
	Partition VARCHAR(255),
	Description VARCHAR(8000),
	Client VARCHAR(255),
	Supplier VARCHAR(255),
	"Link" VARCHAR(255),
	ToolID VARCHAR(50)
);

----------------------------------------------
-- Table structure for t_xrefuser
----------------------------------------------
CREATE TABLE PUB.t_xrefuser ( 
	XrefID VARCHAR(255) PRIMARY KEY,
	"Name" VARCHAR(255),
	"Type" VARCHAR(255) NOT NULL,
	Visibility VARCHAR(255),
	Namespace VARCHAR(255),
	Requirement VARCHAR(255),
	"Constraint" VARCHAR(255),
	Behavior VARCHAR(255),
	Partition VARCHAR(255),
	Description VARCHAR(8000),
	Client VARCHAR(255),
	Supplier VARCHAR(255),
	"Link" VARCHAR(255),
	ToolID VARCHAR(50)
);

----------------------------------------------
-- Table structure for usys_system
----------------------------------------------
CREATE TABLE PUB.usys_system ( 
	Property VARCHAR(50) PRIMARY KEY,
	Value VARCHAR(50)
);

----------------------------------------------
-- Table structure for usysoldtables
----------------------------------------------
CREATE TABLE PUB.usysoldtables ( 
	TableName VARCHAR(50),
	NewName VARCHAR(50),
	RelOrder INTEGER DEFAULT 0,
	FixCode INTEGER
);

----------------------------------------------
-- Table structure for usysqueries
----------------------------------------------
CREATE TABLE PUB.usysqueries ( 
	QueryName VARCHAR(50),
	NewName VARCHAR(50),
	FixCode INTEGER
);

----------------------------------------------
-- Table structure for usystables
----------------------------------------------
CREATE TABLE PUB.usystables ( 
	TableName VARCHAR(50) PRIMARY KEY,
	RelOrder INTEGER DEFAULT 0,
	DisplayName VARCHAR(50),
	FromVer VARCHAR(50),
	ToVer VARCHAR(50)
);

COMMIT;
 

-- INDEXES --
CREATE INDEX IAttributeObjectID 				ON PUB.t_attribute ("Object_ID") ;
CREATE INDEX IAttributeName 					ON PUB.t_attribute ("Name") ;
CREATE INDEX IAttributeTagElementID 			ON PUB.t_attributetag (ElementID);
CREATE INDEX IComplexityTypesNumericWeight 		ON PUB.t_complexitytypes (NumericWeight);
CREATE UNIQUE INDEX UIConnectorGuid				ON PUB.t_connector(ea_guid);   
CREATE INDEX IConnectorConnectorType 			ON PUB.t_connector(Connector_Type);
CREATE INDEX IConnectorDiagramID 				ON PUB.t_connector(DiagramID);
CREATE INDEX IConnectorEndObjectID 				ON PUB.t_connector(End_Object_ID);
CREATE INDEX IConnectorStartObjectID 			ON PUB.t_connector(Start_Object_ID);
CREATE INDEX IConnectorSeqNo 					ON PUB.t_connector(SeqNo);
CREATE INDEX IConnectorStyleEx 					ON PUB.t_connector(StyleEx);
CREATE INDEX IConnectorConstraintConstraint 	ON PUB.t_connectorconstraint("Constraint");
CREATE INDEX IConnectorConstraintConnnectorID 	ON PUB.t_connectorconstraint(ConnectorID);
CREATE INDEX IConnectortagElementID 			ON PUB.t_connectortag(ElementID);
CREATE INDEX IDatatypesProductName				ON PUB.t_datatypes(ProductName);
CREATE INDEX IDatatypesDataType					ON PUB.t_datatypes(DataType);
CREATE UNIQUE INDEX UIDigramGuid 				ON PUB.t_diagram (ea_guid);
CREATE INDEX IDiagramPakageID 					ON PUB.t_diagram (Package_ID);
CREATE INDEX IDiagraminksDiagramID 				ON PUB.t_diagramlinks (DiagramID);
CREATE INDEX IDiagramLinksConnectorID 			ON PUB.t_diagramlinks (ConnectorID);
CREATE INDEX IDiagramobjectsDiagramID 			ON PUB.t_diagramobjects (Diagram_ID);
CREATE INDEX IDiagramobjectsObjectID 			ON PUB.t_diagramobjects ("Object_ID");
CREATE INDEX IDocumentElementID 				ON PUB.t_document (ElementID);
CREATE INDEX IDEcfWeight 						ON PUB.t_ecf (Weight);
CREATE INDEX IEfforttypesNumericWeight 			ON PUB.t_efforttypes (NumericWeight);
CREATE INDEX IMainttypesNumericWeight 			ON PUB.t_mainttypes (NumericWeight);
CREATE INDEX IMetrictypesNumericWeight 			ON PUB.t_metrictypes (NumericWeight);
CREATE UNIQUE INDEX UIObjectGuid 				ON PUB.t_object (ea_guid);
CREATE INDEX IObjectObjectType 					ON PUB.t_object (Object_Type);
CREATE INDEX IObjectClassifier 					ON PUB.t_object (Classifier);
CREATE INDEX IObjectPDATA1 						ON PUB.t_object (PDATA1); 
CREATE INDEX IObjectParentID 					ON PUB.t_object (ParentID);
CREATE INDEX IObjectClassifierguid 				ON PUB.t_object (Classifier_guid);
CREATE INDEX IObjectNType 						ON PUB.t_object (NType);
CREATE INDEX IObjectGenLinks 					ON PUB.t_object (GenLinks); 
CREATE INDEX IObjectcontraintConstraint 		ON PUB.t_objectconstraint ("Constraint");
CREATE INDEX IObjectconstraintObjectID 			ON PUB.t_objectconstraint ("Object_ID");
CREATE INDEX IObjecteffortObjectID 				ON PUB.t_objecteffort ("Object_ID");
CREATE INDEX IObjectmetricsMetricType 			ON PUB.t_objectmetrics (MetricType);
CREATE INDEX IObjectmetricsObjectID 			ON PUB.t_objectmetrics ("Object_ID");
CREATE INDEX IObjectMetricsMetric 				ON PUB.t_objectmetrics (Metric);
CREATE INDEX IObjectproblemsObjectID 			ON PUB.t_objectproblems ("Object_ID");
CREATE INDEX IObjectproblemsProblem 			ON PUB.t_objectproblems (Problem);
CREATE INDEX IObjectpropertiesObjectID 			ON PUB.t_objectproperties ("Object_ID");
CREATE INDEX IObjectrequiresObjectID 			ON PUB.t_objectrequires ("Object_ID");
CREATE INDEX IObjectRequiresRequirement 		ON PUB.t_objectrequires (Requirement);
CREATE INDEX IObjectResourceObjectID			ON PUB.t_objectresource ("Object_ID");
CREATE INDEX IObjectrisksObjectID				ON PUB.t_objectrisks ("Object_ID");
CREATE INDEX IObjectscenariosObjectID 			ON PUB.t_objectscenarios ("Object_ID");
CREATE INDEX IObjecttestsObjectID				ON PUB.t_objecttests ("Object_ID");
CREATE INDEX IObjecttrxTRX 						ON PUB.t_objecttrx (TRX);
CREATE INDEX IObjecttrxObjectID 				ON PUB.t_objecttrx ("Object_ID");
CREATE INDEX IObjecttypesImageID 				ON PUB.t_objecttypes (ImageID);
CREATE INDEX IOperationName 					ON PUB.t_operation ("Name");
CREATE INDEX IOperationObjectID 				ON PUB.t_operation ("Object_ID");
CREATE INDEX IOpParamsOperationID				ON PUB.t_operationparams (OperationID);
CREATE INDEX IOpParamsOpIDPos 					ON PUB.t_operationparams (OperationID, Pos);
CREATE INDEX IOpPostsOperationID 				ON PUB.t_operationposts (OperationID);
CREATE INDEX IOpPresOperationID 				ON PUB.t_operationpres (OperationID);
CREATE INDEX IOpTagElementID 					ON PUB.t_operationtag (ElementID);
CREATE UNIQUE INDEX UIPackageGuid 				ON PUB.t_package (ea_guid);
CREATE INDEX IPackageparentID 					ON PUB.t_package (Parent_ID);
CREATE INDEX IPackageName 						ON PUB.t_package (Name);
CREATE INDEX IProbTypesNumericWeight 			ON PUB.t_problemtypes (NumericWeight);
CREATE INDEX IReqtypesNumericWeight 			ON PUB.t_requiretypes (NumericWeight);
CREATE INDEX IRiskTypesNumericWeight 			ON PUB.t_risktypes (NumericWeight);
CREATE INDEX IRoleConstraintConstraint 			ON PUB.t_roleconstraint (Constraint_);
CREATE INDEX IRoleConstraintConnectorID 		ON PUB.t_roleconstraint (ConnectorID);
CREATE INDEX IScenariotypesNumericWeight 		ON PUB.t_scenariotypes (NumericWeight);
CREATE INDEX ISterotypesStereotype				ON PUB.t_stereotypes (Stereotype);
CREATE UNIQUE INDEX UISecuserUserID	 			ON PUB.t_secuser (UserID);
CREATE INDEX ITcfWeight 						ON PUB.t_tcf (Weight);
CREATE INDEX ITesttypesNumericWeight 			ON PUB.t_testtypes (NumericWeight);
CREATE INDEX ITrxtypesNumericWeight 			ON PUB.t_trxtypes (NumericWeight);
CREATE INDEX IXrefClient 						ON PUB.t_xref (Client);
CREATE INDEX IXrefSupplier 						ON PUB.t_xref (Supplier);
CREATE INDEX TXRefType 							ON PUB.t_xref ("Type");
CREATE INDEX ITXRefName 						ON PUB.t_xref (Name);
CREATE INDEX XRefsystemClient 					ON PUB.t_xrefsystem (Client);
CREATE INDEX XRefsystemSupplier 				ON PUB.t_xrefsystem (Supplier);
CREATE INDEX XRefsystemType 					ON PUB.t_xrefsystem ("Type");
CREATE INDEX XRefuserClient 					ON PUB.t_xrefuser (Client);
CREATE INDEX XRefuserSupplier 					ON PUB.t_xrefuser (Supplier);
CREATE INDEX XRefuserType 						ON PUB.t_xrefuser ("Type");

COMMIT;

GRANT ALL PRIVILEGES ON PUB.t_attribute TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_attributeconstraints TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_attributetag TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_authors TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_cardinality TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_category TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_clients TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_complexitytypes TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_connector TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_connectorconstraint TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_connectortag TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_connectortypes TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_constants TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_constrainttypes TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_datatypes TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_diagram TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_diagramlinks TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_diagramobjects TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_diagramtypes TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_document TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_ecf TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_efforttypes TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_files TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_genopt TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_glossary TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_html TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_image TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_implement TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_issues TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_lists TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_mainttypes TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_method TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_metrictypes TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_object TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_objectconstraint TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_objecteffort TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_objectfiles TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_objectmetrics TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_objectproblems TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_objectproperties TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_objectrequires TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_objectresource TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_objectrisks TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_objectscenarios TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_objecttests TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_objecttrx TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_objecttypes TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_ocf TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_operation TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_operationparams TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_operationposts TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_operationpres TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_operationtag TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_package TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_palette TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_paletteitem TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_phase TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_primitives TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_problemtypes TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_projectroles TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_propertytypes TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_requiretypes TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_resources TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_risktypes TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_roleconstraint TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_rtf TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_rtfreport TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_rules TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_scenariotypes TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_script TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_secgroup TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_secgrouppermission TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_seclocks TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_secpermission TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_secpolicies TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_secuser TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_secusergroup TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_secuserpermission TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_snapshot TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_statustypes TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_stereotypes TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_taggedvalue TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_tasks TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_tcf TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_template TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_testclass TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_testplans TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_testtypes TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_trxtypes TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_umlpattern TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_version TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_xref TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_xrefsystem TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.t_xrefuser TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.usysOldTables TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.usysQueries TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.usysTables TO PUBLIC;
GRANT ALL PRIVILEGES ON PUB.usys_system TO PUBLIC;
COMMIT;
